
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import peer_group
class peer_groups(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-bgp - based on the path /bgp/peer-groups. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration for BGP peer-groups
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_extmethods', '__peer_group',)

  _yang_name = 'peer-groups'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'bgp', u'peer-groups']

  def _get_peer_group(self):
    """
    Getter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    return self.__peer_group
      
  def _set_peer_group(self, v, load=False):
    """
    Setter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_peer_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_peer_group() directly.

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """peer_group must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)""",
        })

    self.__peer_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_peer_group(self):
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

  peer_group = __builtin__.property(_get_peer_group, _set_peer_group)


  _pyangbind_elements = {'peer_group': peer_group, }


import peer_group
class peer_groups(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-bgp-common - based on the path /bgp/peer-groups. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration for BGP peer-groups
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_extmethods', '__peer_group',)

  _yang_name = 'peer-groups'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'bgp', u'peer-groups']

  def _get_peer_group(self):
    """
    Getter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    return self.__peer_group
      
  def _set_peer_group(self, v, load=False):
    """
    Setter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_peer_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_peer_group() directly.

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """peer_group must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)""",
        })

    self.__peer_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_peer_group(self):
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

  peer_group = __builtin__.property(_get_peer_group, _set_peer_group)


  _pyangbind_elements = {'peer_group': peer_group, }


import peer_group
class peer_groups(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-bgp-common-multiprotocol - based on the path /bgp/peer-groups. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration for BGP peer-groups
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_extmethods', '__peer_group',)

  _yang_name = 'peer-groups'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'bgp', u'peer-groups']

  def _get_peer_group(self):
    """
    Getter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    return self.__peer_group
      
  def _set_peer_group(self, v, load=False):
    """
    Setter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_peer_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_peer_group() directly.

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """peer_group must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)""",
        })

    self.__peer_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_peer_group(self):
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

  peer_group = __builtin__.property(_get_peer_group, _set_peer_group)


  _pyangbind_elements = {'peer_group': peer_group, }


import peer_group
class peer_groups(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-bgp-common-structure - based on the path /bgp/peer-groups. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration for BGP peer-groups
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_extmethods', '__peer_group',)

  _yang_name = 'peer-groups'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'bgp', u'peer-groups']

  def _get_peer_group(self):
    """
    Getter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    return self.__peer_group
      
  def _set_peer_group(self, v, load=False):
    """
    Setter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_peer_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_peer_group() directly.

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """peer_group must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)""",
        })

    self.__peer_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_peer_group(self):
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

  peer_group = __builtin__.property(_get_peer_group, _set_peer_group)


  _pyangbind_elements = {'peer_group': peer_group, }


import peer_group
class peer_groups(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-bgp-peer-group - based on the path /bgp/peer-groups. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration for BGP peer-groups
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_extmethods', '__peer_group',)

  _yang_name = 'peer-groups'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'bgp', u'peer-groups']

  def _get_peer_group(self):
    """
    Getter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    return self.__peer_group
      
  def _set_peer_group(self, v, load=False):
    """
    Setter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_peer_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_peer_group() directly.

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """peer_group must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)""",
        })

    self.__peer_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_peer_group(self):
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

  peer_group = __builtin__.property(_get_peer_group, _set_peer_group)


  _pyangbind_elements = {'peer_group': peer_group, }


import peer_group
class peer_groups(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-bgp-neighbor - based on the path /bgp/peer-groups. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration for BGP peer-groups
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_extmethods', '__peer_group',)

  _yang_name = 'peer-groups'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'bgp', u'peer-groups']

  def _get_peer_group(self):
    """
    Getter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    return self.__peer_group
      
  def _set_peer_group(self, v, load=False):
    """
    Setter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_peer_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_peer_group() directly.

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """peer_group must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)""",
        })

    self.__peer_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_peer_group(self):
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

  peer_group = __builtin__.property(_get_peer_group, _set_peer_group)


  _pyangbind_elements = {'peer_group': peer_group, }


import peer_group
class peer_groups(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-bgp-global - based on the path /bgp/peer-groups. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration for BGP peer-groups
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_extmethods', '__peer_group',)

  _yang_name = 'peer-groups'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'bgp', u'peer-groups']

  def _get_peer_group(self):
    """
    Getter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    return self.__peer_group
      
  def _set_peer_group(self, v, load=False):
    """
    Setter method for peer_group, mapped from YANG variable /bgp/peer_groups/peer_group (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_peer_group is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_peer_group() directly.

    YANG Description: List of BGP peer-groups configured on the local system -
uniquely identified by peer-group name
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """peer_group must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)""",
        })

    self.__peer_group = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_peer_group(self):
    self.__peer_group = YANGDynClass(base=YANGListType("peer_group_name",peer_group.peer_group, yang_name="peer-group", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='peer-group-name', extensions=None), is_container='list', yang_name="peer-group", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/bgp', defining_module='openconfig-bgp', yang_type='list', is_config=True)

  peer_group = __builtin__.property(_get_peer_group, _set_peer_group)


  _pyangbind_elements = {'peer_group': peer_group, }


