
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class config(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-interfaces - based on the path /interfaces/interface/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configurable items at the global, physical interface
level
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_extmethods', '__type','__mtu','__name','__description','__enabled',)

  _yang_name = 'config'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    self._path_helper = False

    self._extmethods = False
    self.__enabled = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='boolean', is_config=True)
    self.__description = YANGDynClass(base=unicode, is_leaf=True, yang_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='string', is_config=True)
    self.__type = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_type="dict_key", restriction_arg={u'ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}},), is_leaf=True, yang_name="type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='identityref', is_config=True)
    self.__name = YANGDynClass(base=unicode, is_leaf=True, yang_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='string', is_config=True)
    self.__mtu = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='uint16', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'interfaces', u'interface', u'config']

  def _get_type(self):
    """
    Getter method for type, mapped from YANG variable /interfaces/interface/config/type (identityref)

    YANG Description: [adapted from IETF interfaces model (RFC 7223)]

The type of the interface.

When an interface entry is created, a server MAY
initialize the type leaf with a valid value, e.g., if it
is possible to derive the type from the name of the
interface.

If a client tries to set the type of an interface to a
value that can never be used by the system, e.g., if the
type is not supported or if the type does not match the
name of the interface, the server MUST reject the request.
A NETCONF server MUST reply with an rpc-error with the
error-tag 'invalid-value' in this case.
    """
    return self.__type
      
  def _set_type(self, v, load=False):
    """
    Setter method for type, mapped from YANG variable /interfaces/interface/config/type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_type() directly.

    YANG Description: [adapted from IETF interfaces model (RFC 7223)]

The type of the interface.

When an interface entry is created, a server MAY
initialize the type leaf with a valid value, e.g., if it
is possible to derive the type from the name of the
interface.

If a client tries to set the type of an interface to a
value that can never be used by the system, e.g., if the
type is not supported or if the type does not match the
name of the interface, the server MUST reject the request.
A NETCONF server MUST reply with an rpc-error with the
error-tag 'invalid-value' in this case.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode, restriction_type="dict_key", restriction_arg={u'ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}},), is_leaf=True, yang_name="type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='identityref', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """type must be of a type compatible with identityref""",
          'defined-type': "openconfig-interfaces:identityref",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_type="dict_key", restriction_arg={u'ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}},), is_leaf=True, yang_name="type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='identityref', is_config=True)""",
        })

    self.__type = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_type(self):
    self.__type = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_type="dict_key", restriction_arg={u'ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:qllc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dlsw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88024TokenBus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalChannelGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ss7SigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:wwanPP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cctEmul': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gfp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdh1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbAsiOut': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayMPI': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rs232': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:usb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vmwareNicTeam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88022llc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25mlp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds1FDL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:radioMAC': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstreamChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bits': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ifVfiType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mvl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sixToFour': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sipTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'miox25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ciscoISLvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmbond': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25huntGroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl2plus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mfSigLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:eplrs': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025Dtr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gigabitEthernet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:otnOtu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v11': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:channel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:e1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:regular1822': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ddnX25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rfc877x25': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:proteon10Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetPath': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:teLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gr303IDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:nsip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d1FwdOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:softwareLoopback': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'q2931': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:linegroup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:econet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEM': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbTdm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ilan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:termPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:nfas': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFXO': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdci': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:vmwareVirtualNic': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025TokenRing': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:lmp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:virtualTg': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'vdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pos': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'macSecUncontrolledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableMCmtsDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableNdf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:bsc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds0': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:modem': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ds3': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pppMultilinkBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdns': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9982': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tr008': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:para': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l3ipxvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:imt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propPointToPointSerial': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88026Man': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mpegTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:adsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:localTalk': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frDlciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mpls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gtp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'escon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ultra': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ds0Bundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x213': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbAsiIn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ieee80216WMAN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:starLan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hippi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iana-interface-type': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'qam': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:iso88025CRFPInt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cblVectaStar': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEMFGD': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsOfdmDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:mplsTunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'shdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRccUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:coffee': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee802154': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:wwanPP2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:l3ipvlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'infiniband': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80212': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hostPad': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee80211': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceFGDOS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:if-gsn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'l2vlan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:x86Laps': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fastEtherFX': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aal5': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:smdsIcip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapf': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:homepna': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aal2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gfast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmVciEndPt': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:idsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:h323Proxy': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:atmSubInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:actelisMetaLOOP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hyperchannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ptm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rsrb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ibm370parChan': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mpc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayInterconnect': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:proteon80Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRcsMacLayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bridge': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:mediaMailOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ipOverCdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propWirelessP2P': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:dvbRccDownstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'x25ple': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:vdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propVirtual': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:propAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:compositeLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluGponOnu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arcnet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverFrameRelay': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ethernet3Mbit': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:smdsDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ipOverClaw': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:eon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'plc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'radsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceEncap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pon155': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d2UsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceOverCable': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pdnEtherLoop2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:slip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:async': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapWtpVirtualRadio': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:cableDownstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'srp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pon622': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:bgppolicyaccounting': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipForward': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'tdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:basicISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessMaclayer': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propDocsWirelessUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:primaryISDN': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:otnOdu': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ppp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:arap': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:fcipLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88023Csmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:digitalWrapperOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'atmFuni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableNdr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fast': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'digitalPowerline': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aflane8023': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aflane8025': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceOverIp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapDot11Profile': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sonetOverheadChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableScte55d2DsOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceDID': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:ieee1394': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:fddi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:docsCableScte55d1RetOob': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:sdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:gr303RDT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:arcnetPlus': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceOverAtm': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:opticalTransport': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:frf16MfrBundle': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmDxi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:aluELP': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sipSig': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:stackToStack': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'mocaVersion1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ethernetCsmacd': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:interleave': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ipSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:xboxWireless': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v35': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v36': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'v37': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g703at64k': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9983': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pip': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:g703at2mb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmLogical': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'adsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'h323Gatekeeper': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:gpon': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'isdn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'capwapDot11Bss': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:reachDSL': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:myrinet': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluEponLogicalLink': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'voiceEBS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:voiceFXS': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dvbRcsTdma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:atmIma': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'docsOfdmaUpstream': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propCnls': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hssi': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:propMultiplexor': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'iso88025Fiber': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:docsCableUpstreamRfPort': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:g9981': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'a12MppSwitch': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:rpr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ieee8023adLag': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:other': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:isup': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ces': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdsl2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:pdnEtherLoop1': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:cnr': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'hiperlan2': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:macSecControlledIF': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'sdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:hdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:frameRelayService': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:tunnel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:aluGponPhysicalUni': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:voiceFGDEANA': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:ifPwType': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'fibreChannel': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:hippiInterface': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:transpHdlc': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:rfc1483': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:sonetVT': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:msdsl': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:dcn': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ift:virtualIpAddress': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'aviciOpticalEther': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'propBWAp2Mp': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}, u'ianaift:lapb': {'@namespace': u'urn:ietf:params:xml:ns:yang:iana-if-type', '@module': u'iana-if-type'}},), is_leaf=True, yang_name="type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='identityref', is_config=True)


  def _get_mtu(self):
    """
    Getter method for mtu, mapped from YANG variable /interfaces/interface/config/mtu (uint16)

    YANG Description: Set the max transmission unit size in octets
for the physical interface.  If this is not set, the mtu is
set to the operational default -- e.g., 1514 bytes on an
Ethernet interface.
    """
    return self.__mtu
      
  def _set_mtu(self, v, load=False):
    """
    Setter method for mtu, mapped from YANG variable /interfaces/interface/config/mtu (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mtu is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mtu() directly.

    YANG Description: Set the max transmission unit size in octets
for the physical interface.  If this is not set, the mtu is
set to the operational default -- e.g., 1514 bytes on an
Ethernet interface.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='uint16', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """mtu must be of a type compatible with uint16""",
          'defined-type': "uint16",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='uint16', is_config=True)""",
        })

    self.__mtu = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_mtu(self):
    self.__mtu = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='uint16', is_config=True)


  def _get_name(self):
    """
    Getter method for name, mapped from YANG variable /interfaces/interface/config/name (string)

    YANG Description: [adapted from IETF interfaces model (RFC 7223)]

The name of the interface.

A device MAY restrict the allowed values for this leaf,
possibly depending on the type of the interface.
For system-controlled interfaces, this leaf is the
device-specific name of the interface.  The 'config false'
list interfaces/interface[name]/state contains the currently
existing interfaces on the device.

If a client tries to create configuration for a
system-controlled interface that is not present in the
corresponding state list, the server MAY reject
the request if the implementation does not support
pre-provisioning of interfaces or if the name refers to
an interface that can never exist in the system.  A
NETCONF server MUST reply with an rpc-error with the
error-tag 'invalid-value' in this case.

The IETF model in RFC 7223 provides YANG features for the
following (i.e., pre-provisioning and arbitrary-names),
however they are omitted here:

 If the device supports pre-provisioning of interface
 configuration, the 'pre-provisioning' feature is
 advertised.

 If the device allows arbitrarily named user-controlled
 interfaces, the 'arbitrary-names' feature is advertised.

When a configured user-controlled interface is created by
the system, it is instantiated with the same name in the
/interfaces/interface[name]/state list.
    """
    return self.__name
      
  def _set_name(self, v, load=False):
    """
    Setter method for name, mapped from YANG variable /interfaces/interface/config/name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_name() directly.

    YANG Description: [adapted from IETF interfaces model (RFC 7223)]

The name of the interface.

A device MAY restrict the allowed values for this leaf,
possibly depending on the type of the interface.
For system-controlled interfaces, this leaf is the
device-specific name of the interface.  The 'config false'
list interfaces/interface[name]/state contains the currently
existing interfaces on the device.

If a client tries to create configuration for a
system-controlled interface that is not present in the
corresponding state list, the server MAY reject
the request if the implementation does not support
pre-provisioning of interfaces or if the name refers to
an interface that can never exist in the system.  A
NETCONF server MUST reply with an rpc-error with the
error-tag 'invalid-value' in this case.

The IETF model in RFC 7223 provides YANG features for the
following (i.e., pre-provisioning and arbitrary-names),
however they are omitted here:

 If the device supports pre-provisioning of interface
 configuration, the 'pre-provisioning' feature is
 advertised.

 If the device allows arbitrarily named user-controlled
 interfaces, the 'arbitrary-names' feature is advertised.

When a configured user-controlled interface is created by
the system, it is instantiated with the same name in the
/interfaces/interface[name]/state list.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=unicode, is_leaf=True, yang_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='string', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """name must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=unicode, is_leaf=True, yang_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='string', is_config=True)""",
        })

    self.__name = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_name(self):
    self.__name = YANGDynClass(base=unicode, is_leaf=True, yang_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='string', is_config=True)


  def _get_description(self):
    """
    Getter method for description, mapped from YANG variable /interfaces/interface/config/description (string)

    YANG Description: [adapted from IETF interfaces model (RFC 7223)]

A textual description of the interface.

A server implementation MAY map this leaf to the ifAlias
MIB object.  Such an implementation needs to use some
mechanism to handle the differences in size and characters
allowed between this leaf and ifAlias.  The definition of
such a mechanism is outside the scope of this document.

Since ifAlias is defined to be stored in non-volatile
storage, the MIB implementation MUST map ifAlias to the
value of 'description' in the persistently stored
datastore.

Specifically, if the device supports ':startup', when
ifAlias is read the device MUST return the value of
'description' in the 'startup' datastore, and when it is
written, it MUST be written to the 'running' and 'startup'
datastores.  Note that it is up to the implementation to

decide whether to modify this single leaf in 'startup' or
perform an implicit copy-config from 'running' to
'startup'.

If the device does not support ':startup', ifAlias MUST
be mapped to the 'description' leaf in the 'running'
datastore.
    """
    return self.__description
      
  def _set_description(self, v, load=False):
    """
    Setter method for description, mapped from YANG variable /interfaces/interface/config/description (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_description is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_description() directly.

    YANG Description: [adapted from IETF interfaces model (RFC 7223)]

A textual description of the interface.

A server implementation MAY map this leaf to the ifAlias
MIB object.  Such an implementation needs to use some
mechanism to handle the differences in size and characters
allowed between this leaf and ifAlias.  The definition of
such a mechanism is outside the scope of this document.

Since ifAlias is defined to be stored in non-volatile
storage, the MIB implementation MUST map ifAlias to the
value of 'description' in the persistently stored
datastore.

Specifically, if the device supports ':startup', when
ifAlias is read the device MUST return the value of
'description' in the 'startup' datastore, and when it is
written, it MUST be written to the 'running' and 'startup'
datastores.  Note that it is up to the implementation to

decide whether to modify this single leaf in 'startup' or
perform an implicit copy-config from 'running' to
'startup'.

If the device does not support ':startup', ifAlias MUST
be mapped to the 'description' leaf in the 'running'
datastore.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=unicode, is_leaf=True, yang_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='string', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """description must be of a type compatible with string""",
          'defined-type': "string",
          'generated-type': """YANGDynClass(base=unicode, is_leaf=True, yang_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='string', is_config=True)""",
        })

    self.__description = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_description(self):
    self.__description = YANGDynClass(base=unicode, is_leaf=True, yang_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='string', is_config=True)


  def _get_enabled(self):
    """
    Getter method for enabled, mapped from YANG variable /interfaces/interface/config/enabled (boolean)

    YANG Description: [adapted from IETF interfaces model (RFC 7223)]

This leaf contains the configured, desired state of the
interface.

Systems that implement the IF-MIB use the value of this
leaf in the 'running' datastore to set
IF-MIB.ifAdminStatus to 'up' or 'down' after an ifEntry
has been initialized, as described in RFC 2863.

Changes in this leaf in the 'running' datastore are
reflected in ifAdminStatus, but if ifAdminStatus is
changed over SNMP, this leaf is not affected.
    """
    return self.__enabled
      
  def _set_enabled(self, v, load=False):
    """
    Setter method for enabled, mapped from YANG variable /interfaces/interface/config/enabled (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enabled is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enabled() directly.

    YANG Description: [adapted from IETF interfaces model (RFC 7223)]

This leaf contains the configured, desired state of the
interface.

Systems that implement the IF-MIB use the value of this
leaf in the 'running' datastore to set
IF-MIB.ifAdminStatus to 'up' or 'down' after an ifEntry
has been initialized, as described in RFC 2863.

Changes in this leaf in the 'running' datastore are
reflected in ifAdminStatus, but if ifAdminStatus is
changed over SNMP, this leaf is not affected.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='boolean', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enabled must be of a type compatible with boolean""",
          'defined-type': "boolean",
          'generated-type': """YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='boolean', is_config=True)""",
        })

    self.__enabled = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enabled(self):
    self.__enabled = YANGDynClass(base=YANGBool, default=YANGBool("true"), is_leaf=True, yang_name="enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/interfaces', defining_module='openconfig-interfaces', yang_type='boolean', is_config=True)

  type = __builtin__.property(_get_type, _set_type)
  mtu = __builtin__.property(_get_mtu, _set_mtu)
  name = __builtin__.property(_get_name, _set_name)
  description = __builtin__.property(_get_description, _set_description)
  enabled = __builtin__.property(_get_enabled, _set_enabled)


  _pyangbind_elements = {'type': type, 'mtu': mtu, 'name': name, 'description': description, 'enabled': enabled, }


